using System;
using XDesigner.Common ;
using XDesigner.ORM;
using System.Text;
using System.Data;

namespace XDesigner.DataSourceDom
{
	/// <summary>
	/// DataSourceUtil ժҪ˵
	/// </summary>
	internal sealed class DataSourceUtil
	{
        //public static string ValidateDataSourceDocument(DataSourceDocument document)
        //{
        //}

        //private static void ValidateDataSourceElement(DataSourceElement rootElement, StringBuilder output)
        //{
        //    if (System.Xml.XmlReader.IsName(rootElement.Name) == false)
        //    {
        //        output.AppendLine(string.Format(DataSourceStrings.InvalidateNodeName_Path, rootElement.FullPath));
        //    }
        //    if (DataSourceUtil.HasContent(rootElement.FieldName) == false && rootElement.Parent is DataSourceElement)
        //    {
        //        output.AppendLine( string.Format( DataSourceStrings.InvalidateRequireFieldName_Path , rootElement.FullPath ));
        //    }
        //    //foreach( 
        //}

        public static string[] ValueToStrings(object[] Values)
        {
            if (Values == null)
                return null;
            string[] texts = new string[Values.Length];
            for (int iCount = 0; iCount < Values.Length; iCount++)
            {
                object v = Values[iCount];
                if (v == null || DBNull.Value.Equals(v))
                    texts[iCount] = null;
                else
                    texts[iCount] = Convert.ToString(v);
            }
            return texts;
        }
           
		public static object[] GetGroupValues( System.Data.DataTable table , System.Data.DataRow[] rows , int FieldIndex )
		{
			System.Collections.ArrayList list = new System.Collections.ArrayList();
			foreach( System.Data.DataRow row in rows )
			{
				object key = row[ FieldIndex ] ;
				bool find = false;
				foreach( object v in list )
				{
					if( EqualsValue( key , v ))
					{
						find = true ;
						break;
					}
				}
				if( find == false )
				{
					list.Add( key );
				}
			}
			return list.ToArray();
		}

		public static bool EqualsValue( object v1 , object v2 )
		{
			if( v1 == v2 )
				return true ;
			if( v1 != null )
			{
				return v1.Equals( v2 );
			}
			if( v2 != null )
			{
				return v2.Equals( v1 );
			}
			return false;
		}

//		/// <summary>
//		/// һݱֶָνз
//		/// </summary>
//		/// <param name="table">ݱ</param>
//		/// <param name="Rows">жб</param>
//		/// <param name="FieldIndex">ֶ</param>
//		/// <returns></returns>
//		public static System.Collections.Hashtable GroupDataTable( System.Data.DataTable table , System.Collections.IEnumerable Rows , int FieldIndex )
//		{
//			if( Rows == null )
//			{
//				Rows = table.Rows ;
//			}
//			System.Collections.Hashtable result = new System.Collections.Hashtable();
//			foreach( System.Data.DataRow row in Rows )
//			{
//				object key = row[ FieldIndex ] ;
//				System.Collections.ArrayList list = result[ key ] as System.Collections.ArrayList ;
//				if( list == null )
//				{
//					list = new System.Collections.ArrayList();
//					result[ key ] = list ;
//				}
//				list.Add( row );
//			}
//			foreach( object key in result.Keys )
//			{
//				System.Collections.ArrayList list = ( System.Collections.ArrayList ) result[ key ]  ;
//				result[ key ] = list.ToArray( typeof( System.Data.DataRow ));
//			}
//			return result ;
//		}

		public static string FixDataSourceName ( string vName )
		{
			if( System.Xml.XmlReader.IsName( vName ))
				return vName ;
			System.Text.StringBuilder myStr = new System.Text.StringBuilder();
			foreach( char c in vName )
			{
				if( System.Xml.XmlReader.IsName( c.ToString()))
					myStr.Append( c );
				else
					myStr.Append("_");
			}
			return myStr.ToString();
		}

		/// <summary>
		/// жһַǷ,isBlankString෴
		/// </summary>
		/// <param name="strData">ַ</param>
		/// <returns>ַΪҴڷǿհַ򷵻True 򷵻False</returns>
		public static bool HasContent( string strData )
		{
			if( strData != null && strData.Length > 0 )
			{
				foreach(char c in strData )
				{
					if( Char.IsWhiteSpace( c ) == false)
						return true;
				}
			}
			return false;
		}// bool HasContent()

        /// <summary>
        /// ݶıøö󶨵ֶ
        /// </summary>
        /// <param name="text">ı</param>
        /// <returns>õİ󶨵ĵһֶ</returns>
        public static string GetBindingFieldName(string text)
        {
            string[] items = VariableString.AnalyseVariableString(text, "[", "]");
            if (items == null || items.Length <= 1)
                return null;
            for (int iCount = 0; iCount < items.Length; iCount++)
            {
                if ((iCount % 2) == 1)
                {
                    string name = items[iCount];
                    if (System.Xml.XmlReader.IsName(name))
                    {
                        return name;
                    }
                }
            }//for
            return null;
        }

        public static bool IsInBinding(string txt, int index)
		{
			if( txt == null )
				return false;
			if( index <= 0 || index > txt.Length - 1 )
				return false;

			bool start = false;
			for( int iCount = index -1 ; iCount >= 0 ; iCount -- )
			{
				char c = txt[ iCount ] ;
				if( c == ']' || c == '[' )
				{
					if( c == '[' )
						start = true;
					break;
				}
			}
			
			if( start == false )
				return false;

			bool end = false;
			for( int iCount = index ; iCount < txt.Length ; iCount ++ )
			{
				char c = txt[ iCount ] ;
				if( c == ']' || c == '[' )
				{
					if( c == ']' )
						end = true;
					break;
				}
			}

			return end ;
		}

		public static string[] GetVariableNames( string strText )
		{
			VariableString str = new VariableString( strText );
			return str.GetVariableNames();
		}
         
        public static string ExecuteVariableString(
            string strCommandText,
            System.Collections.ArrayList ParameterValues,
            IVariableProvider vars)
        {
            VariableString str = new VariableString(strCommandText);
            str.Variables = vars;
            return str.Execute(ParameterValues);
        }


        public static string ExecuteVariableString(
			string strCommandText , 
			System.Collections.ArrayList ParameterValues ,
			IVariableProvider vars ,
            ParameterStyle parameterStyle )
		{
			VariableString str = new VariableString( strCommandText );
			str.Variables = vars ;
            switch (parameterStyle)
            {
                case ParameterStyle.Default :
                    str.NamedParameter = true;
                    str.ParameterNamePrefix = "@";
                    return str.Execute( );
                case ParameterStyle.Macro :
                    str.NamedParameter = false ;
                    return str.Execute();
                case ParameterStyle.Anonymous :
                    str.ParameterNamePrefix = null;
                    str.NamedParameter = false;
                    return str.Execute(ParameterValues);
                case ParameterStyle.OracleStyle :
                    str.NamedParameter = true;
                    str.ParameterNamePrefix = ":";
                    return str.Execute(ParameterValues);
                case ParameterStyle.SQLServerStyle :
                    str.NamedParameter = true;
                    str.ParameterNamePrefix = "@";
                    return str.Execute(ParameterValues);
            }
            throw new ArgumentException("parameterStyle");
		}

        public static void DebugPrintCommandInfo( string source , System.Data.IDbCommand command )
        {
            System.Diagnostics.Debug.WriteLine( source + ":" + command.CommandText);
            foreach (IDataParameter p in command.Parameters)
            {
                if (p.Value == null || DBNull.Value.Equals(p.Value))
                {
                    System.Diagnostics.Debug.WriteLine(p.ParameterName + "\t=NULL");
                }
                else
                {
                    System.Diagnostics.Debug.WriteLine(p.ParameterName + "\t=\"" + p.Value + "\"");
                }
            }
        }


        public static void AppendParameterSQL(
            StringBuilder mySQL,
            string fieldName,
            object Value,
            ParameterStyle parameterStyle )
        {
            AppendParameterSQL(mySQL, fieldName, Value, parameterStyle, null);
        }

        public static void AppendParameterSQL(
            StringBuilder mySQL,
            string fieldName, 
            object Value , 
            ParameterStyle parameterStyle ,
            IDbCommand command )
        {
            if (Value == null)
            {
                Value = DBNull.Value;
            }
            if (Value is string)
            {
                string str = (string)Value;
                if (str == null || str.Length == 0)
                {
                    Value = DBNull.Value;
                }
            }
            switch (parameterStyle)
            {
                case ParameterStyle.Anonymous:
                    mySQL.Append(" ? ");
                    if (command != null)
                    {
                        IDbDataParameter p = command.CreateParameter();
                        p.Value = Value;
                        command.Parameters.Add(p);
                    }
                    break;
                case ParameterStyle.Default:
                    mySQL.Append(" ? ");
                    if (command != null)
                    {
                        IDbDataParameter p = command.CreateParameter();
                        p.Value = Value;
                        command.Parameters.Add(p);
                    }
                    break;
                case ParameterStyle.Macro:
                    if (Value == null || DBNull.Value.Equals(Value))
                    {
                        mySQL.Append(" null ");
                    }
                    else if (Value is string)
                    {
                        string str = (string)Value;
                        if (str.Length == 0)
                        {
                            mySQL.Append(" null ");
                        }
                        else
                        {
                            if (str.IndexOf("'") >= 0)
                            {
                                str = str.Replace("'", "''");
                            }
                            mySQL.Append("'" + str + "'");
                        }
                    }
                    else if (Value is byte[])
                    {
                        byte[] bs = (byte[])Value;
                        if (bs.Length == 0)
                        {
                            mySQL.Append(" null ");
                        }
                        else
                        {
                            char[] hexs = "0123456789ABCDEF".ToCharArray();
                            mySQL.Append("0x");
                            for (int iCount = 0; iCount < bs.Length; iCount++)
                            {
                                byte b = bs[iCount];
                                mySQL.Append(hexs[b >> 4]);
                                mySQL.Append(hexs[b & 15]);
                            }
                        }
                    }
                    else if (Value is DateTime)
                    {
                        mySQL.Append("'" + Value.ToString() + "'");
                    }
                    else
                    {
                        mySQL.Append(Value.ToString());
                    }
                    break;
                case ParameterStyle.OracleStyle:
                    mySQL.Append(":" + fieldName);
                    if (command != null)
                    {
                        IDbDataParameter p = command.CreateParameter();
                        p.ParameterName = fieldName;
                        p.Value = Value;
                        command.Parameters.Add(p);
                    }
                    break;
                case ParameterStyle.SQLServerStyle:
                    mySQL.Append("@" + fieldName);
                    if (command != null)
                    {
                        IDbDataParameter p = command.CreateParameter();
                        p.ParameterName = fieldName;
                        p.Value = Value;
                        command.Parameters.Add(p);
                    }
                    break;
                default:
                    mySQL.Append("@" + fieldName);
                    if (command != null)
                    {
                        IDbDataParameter p = command.CreateParameter();
                        p.ParameterName = fieldName;
                        p.Value = Value;
                        command.Parameters.Add(p);
                    }
                    break;
            }//switch
        }

		private DataSourceUtil()
		{
		}
	}
}
