﻿using System;
using System.Text;
using System.Data ;

namespace XDesigner.ORM
{
    public class ORMContext
    {
        public ORMContext( ORMEngine work )
        {
            if (work != null)
            {
                _Framework = work;
                _ParameterStyle = work.Config.ParameterStyle;
                _Command.Framework = work;
            }
        }

        private ORMInstanceBuffer _Buffer = new ORMInstanceBuffer();

        public ORMInstanceBuffer Buffer
        {
            get { return _Buffer; }
            set { _Buffer = value; }
        }

        private ORMDBCommand _Command = new ORMDBCommand();

        public ORMDBCommand Command
        {
            get
            {
                return _Command; 
            }
            set
            {
                _Command = value;
                if (_Command != null)
                {
                    _Command.Framework = this._Framework;
                }
            }
        }

        private ParameterStyle _ParameterStyle = ParameterStyle.SQLServerStyle;

        public ParameterStyle ParameterStyle
        {
            get { return _ParameterStyle; }
            set { _ParameterStyle = value; }
        }

        private ORMEngine _Framework = null;

        public ORMEngine Framework
        {
            get
            {
                return _Framework; 
            }
            set
            {
                _Framework = value;
                _Command.Framework = value;
            }
        }

        internal bool ForGenerateCode = false;
    }
}
