﻿using System;
using System.Text;

namespace XDesigner.ORM
{
    /// <summary>
    /// Special id genereate style
    /// </summary>
    [AttributeUsage( AttributeTargets.Property )]
    public class ORMIDGenerateAttribute : Attribute 
    {
        public ORMIDGenerateAttribute(ORMIDGenerateStyle style)
        {
            _Style = style;
        }

        public ORMIDGenerateAttribute(ORMIDGenerateStyle style, string format)
        {
            _Style = style;
            _Format = format;
        }

        private ORMIDGenerateStyle _Style = ORMIDGenerateStyle.Increase;
        public ORMIDGenerateStyle Style
        {
            get
            {
                return _Style;
            }
            set
            {
                _Style = value;
            }
        }

        private string _Format = null;

        public string Format
        {
            get { return _Format; }
            set { _Format = value; }
        }
    }

    public enum ORMIDGenerateStyle
    {
        /// <summary>
        /// Auto increase 
        /// </summary>
        Increase ,
        /// <summary>
        /// GUID
        /// </summary>
        GUID,
        /// <summary>
        /// Use current date and time
        /// </summary>
        CurrentTime,
        /// <summary>
        /// Custom generate id of new record
        /// </summary>
        Custom
    }
}
