﻿using System;
using System.Collections.Generic;
using System.Text;

namespace XDesigner.ORM
{
    [AttributeUsage( AttributeTargets.Property )]
    public class ORMOneToManyAttribute : Attribute 
    {
        public ORMOneToManyAttribute()
        {
        }

        public ORMOneToManyAttribute(string childFieldName)
        {
            this._childFieldName = childFieldName;
        }

        private string _parentFieldName = null;
        /// <summary>
        /// Parent table field name
        /// </summary>
        public string ParentFieldName
        {
            get { return _parentFieldName; }
            set { _parentFieldName = value; }
        }

        private string _childFieldName = null;
        /// <summary>
        /// Child table field name relation
        /// </summary>
        public string ChildFieldName
        {
            get { return _childFieldName; }
            set { _childFieldName = value; }
        }
         
    }
}
