﻿using System;
using System.Text;

namespace XDesigner.ORM
{
    /// <summary>
    /// Attribute special information bind data table
    /// </summary>
    [System.AttributeUsage( 
        AttributeTargets.Class
        | AttributeTargets.Struct
        | AttributeTargets.Enum
        | AttributeTargets.Interface )]
    public class ORMTypeAttribute : Attribute 
    {
        /// <summary>
        /// Initialize instance
        /// </summary>
        public ORMTypeAttribute()
        {
        }

        /// <summary>
        /// Initalize instance
        /// </summary>
        /// <param name="tableName">data base table name</param>
        public ORMTypeAttribute(string tableName)
        {
            strTableName = tableName;
        }

        private string strTableName = null;
        /// <summary>
        /// Data base table name
        /// </summary>
        public string TableName
        {
            get
            {
                return strTableName;
            }
            set
            {
                strTableName = value;
            }
        }

        private bool _Buffered = false;
        /// <summary>
        /// Instance of this type buffered.
        /// </summary>
        [System.ComponentModel.DefaultValue(false)]
        public bool Buffered
        {
            get { return _Buffered; }
            set { _Buffered = value; }
        }

    }
}
