﻿using System;
using System.Collections.Generic;
using System.Text;
using XDesigner.ORM;
using XDesigner.ORM.DOM;
using System.Data;

namespace XDesigner.ORM.Test
{
    public class CustomerClassORMTypeMappingHelper : XDesigner.ORM.DOM.ORMTypeMappingHelper
    {
        public CustomerClassORMTypeMappingHelper()
        {

        }

        public override bool SupportDelayLoad
        {
            get
            {
                return true;
            }
        }

        public override Type InstanceType
        {
            get
            {
                return typeof(CustomerClassORMTemp);
            }
        }

        public override object CreateInstance()
        {
            return new CustomerClassORMTemp();
        }


        public override bool FillInstance(ORMContext context, IDataReader reader, object instance, List<RelationPropertyValue> relationValues)
        {
            CustomerClass obj = (CustomerClass)instance;
            if (instance is CustomerClassORMTemp)
            {
                CustomerClassORMTemp temp = (CustomerClassORMTemp)instance;
                temp._Work = context.Framework;
            }

            int fieldCount = reader.FieldCount;
            for (int iCount = 0; iCount < fieldCount; iCount++)
            {
                string name = reader.GetName(iCount);
                name = name.Trim().ToLower();
                switch (name)
                {
                    case "customerid":
                        obj.ID = DBValueToString( reader.GetValue( iCount ) , null );
                        if (context.Framework.Config.EnableDelayLoad == false )
                        {
                            if (relationValues != null)
                            {
                                relationValues.Add(new RelationPropertyValue(
                                    instance, this.ORMType.Properties["Orders"], obj.ID));
                            }
                        }
                        break;
                    case "address":
                        obj.Address = DBValueToString(reader.GetValue(iCount),null);
                        break;
                    case "city":
                        obj.City = DBValueToString(reader.GetValue(iCount),null);
                        break;
                    case "companyname":
                        obj.CompanyName = DBValueToString(reader.GetValue(iCount), null);
                        break;
                    case "contactname":
                        obj.ContactName = DBValueToString(reader.GetValue(iCount), null);
                        break;
                    case "contacttitle":
                        obj.ContactTitle = DBValueToString(reader.GetValue(iCount), null);
                        break;
                    case  "country":
                        obj.Country = DBValueToString(reader.GetValue(iCount), null);
                        break;
                    case "email":
                        obj.Email = DBValueToString(reader.GetValue(iCount), null);
                        break;
                    case "fax":
                        obj.Fax = DBValueToString(reader.GetValue(iCount), null);
                        break;
                    case "phone":
                        obj.Phone = DBValueToString(reader.GetValue(iCount), null);
                        break;
                    case "postalcode":
                        obj.PostalCode = DBValueToString(reader.GetValue(iCount), null);
                        break;
                    case "region":
                        obj.Region = DBValueToString(reader.GetValue(iCount), null);
                        break;
                    case "website":
                        obj.WebSite = DBValueToString(reader.GetValue(iCount), null);
                        break; 
                }//switch
            }//for

            return true;
        }//

        public override string GetPropertyCommandText(string propertyName)
        {
            if (propertyName == null || propertyName.Trim().Length == 0)
            {
                return null;
            }
            switch (propertyName.Trim().ToLower())
            {
                case "orders":
                    return "Select CustomerID , EmployeeID , OrderDate , RequireDate , ShippedDate , ShipVia , Freight , ShipName , ShipAddress , ShipCity , ShipRegion , ShipPostalCode , ShipCountry From Orders Where CustoemrID = @ID";
            }
            return null;
        }

        public override object GetDBValue(IDataReader reader, string propertyName)
        {
            if (propertyName == null || propertyName.Trim().Length == 0)
            {
                return DBNull.Value;
            }
            switch (propertyName.Trim().ToLower())
            {
                case "id":
                    return InnerGetDBValue(reader, "CustomerID", null, null);
                case "address":
                    return InnerGetDBValue(reader, "Address", null, null);
                case "city":
                    return InnerGetDBValue(reader, "City", null, null);
                case "companyname":
                    return InnerGetDBValue(reader, "CompanyName", null, null);
                case "contactname":
                    return InnerGetDBValue(reader, "ContactName", null, null);
                case "contacttitle":
                    return InnerGetDBValue(reader, "ContactTitle", null, null);
                case "country":
                    return InnerGetDBValue(reader, "Country", null, null);
                case "email":
                    return InnerGetDBValue(reader, "Email", null, null);
                case "fax":
                    return InnerGetDBValue(reader, "Fax", null, null);
                case "phone":
                    return InnerGetDBValue(reader, "Phone", null, null);
                case "postalcode":
                    return InnerGetDBValue(reader, "PostalCode", null, null);
                case "region":
                    return InnerGetDBValue(reader, "Regioin", null, null);
                case "website":
                    return InnerGetDBValue(reader, "WebSite", null, null);
            }
            return DBNull.Value;
        }

        public override object GenerateID(ORMContext context)
        {
            return System.Guid.NewGuid().ToString();
        }

        public override object GetKeyValue(object instance)
        {
            return ((CustomerClass)instance).ID;
        }

        public override object GetPropertyValue(object instance, string propertyName)
        {
            if (propertyName == null || propertyName.Trim().Length == 0)
            {
                throw new ArgumentNullException("propertyName");
            }
            if (instance == null)
            {
                throw new ArgumentNullException("instance");
            }
            CustomerClass obj = (CustomerClass)instance;
            switch (propertyName.Trim().ToLower())
            {
                case "id":
                    return obj.ID;
                case "address":
                    return obj.Address;
                case "city":
                    return obj.City;
                case "companyname":
                    return obj.CompanyName;
                case "contactname":
                    return obj.ContactName;
                case "contacttitle":
                    return obj.ContactTitle;
                case "country":
                    return obj.Country;
                case "email":
                    return obj.Email;
                case "fax":
                    return obj.Fax;
                case "phone":
                    return obj.Phone;
                case "postalcode":
                    return obj.PostalCode;
                case "region":
                    return obj.Region;
                case "website":
                    return obj.WebSite;
                default :
                    throw new NotSupportedException(propertyName);
            }
        }

        public override void SetPropertyValue(object instance, string propertyName, object Value)
        {
            if (propertyName == null || propertyName.Trim().Length == 0)
            {
                throw new ArgumentNullException("propertyName");
            }
            if (instance == null)
            {
                throw new ArgumentNullException("instance");
            }
            CustomerClass obj = (CustomerClass)instance;
            switch (propertyName.Trim().ToLower())
            {
                case "id":
                    obj.ID = Convert.ToString( Value ) ;
                    break;
                case "address":
                    obj.Address = Convert.ToString(Value);
                    break;
                case "city":
                    obj.City = Convert.ToString(Value);
                    break;
                case "companyname":
                    obj.CompanyName = Convert.ToString(Value);
                    break;
                case "contactname":
                    obj.ContactName = Convert.ToString(Value);
                    break;
                case "contacttitle":
                    obj.ContactTitle = Convert.ToString(Value);
                    break;
                case "country":
                    obj.Country = Convert.ToString(Value);
                    break;
                case "email":
                    obj.Email = Convert.ToString(Value);
                    break;
                case "fax":
                    obj.Fax = Convert.ToString(Value);
                    break;
                case "phone":
                    obj.Phone = Convert.ToString(Value);
                    break;
                case "postalcode":
                    obj.PostalCode = Convert.ToString(Value);
                    break;
                case "region":
                    obj.PostalCode = Convert.ToString(Value);
                    break;
                case "website":
                    obj.WebSite = Convert.ToString(Value);
                    break;
                default:
                    throw new NotSupportedException(propertyName);
            }
        }


        public override bool PrepareDeleteCommand(ORMContext context, object instance)
        {
            CustomerClass obj = (CustomerClass)instance;
            context.Command.Parameters.Clear();
            context.Command.CommandText = "Delete From Customers Where CustomerID = @ID";
            ORMDBParameter p = new ORMDBParameter();
            p.ParameterName = "ID";
            p.Value = obj.ID;
            context.Command.Parameters.Add(p);
            return true;
        }

        public override bool PrepareInsertCommand(ORMContext context, object instance)
        {
            CustomerClass obj = ( CustomerClass ) instance ;
            context.Command.Parameters.Clear();
            context.Command.CommandText = @"
Insert Into Customers 
( CustomerID , Address , City , CompanyName , ContactName , ContactTitle , Country , Email, Fax , Phone , PostalCode , Region , WebSite )
Values
( @CustomerID , @Address , @City , @CompanyName , @ContactName , @ContactTitle , @Country , @Email, @Fax , @Phone , @PostalCode , @Region , @WebSite )";
            context.Command.Parameters.AddParameter("CustomerID", obj.ID);
            context.Command.Parameters.AddParameter("Address", obj.Address);
            context.Command.Parameters.AddParameter("City", obj.City);
            context.Command.Parameters.AddParameter("CompanyName", obj.CompanyName);
            context.Command.Parameters.AddParameter("ContanctName", obj.ContactName);
            context.Command.Parameters.AddParameter("ContactTitle", obj.ContactTitle);
            context.Command.Parameters.AddParameter("Country", obj.Country);
            context.Command.Parameters.AddParameter("EMail", obj.Email);
            context.Command.Parameters.AddParameter("Fax", obj.Fax);
            context.Command.Parameters.AddParameter("Phone", obj.Phone);
            context.Command.Parameters.AddParameter("PostalCode", obj.PostalCode);
            context.Command.Parameters.AddParameter("Region", obj.Region);
            context.Command.Parameters.AddParameter("WebSite", obj.WebSite);

            return true;
        }

        public override bool PrepareUpdateCommand(ORMContext context, object instance)
        {
            CustomerClass obj = (CustomerClass)instance;
            context.Command.Parameters.Clear();
            context.Command.CommandText = @"
Update Customers Set 
    Address = @Address , 
    City    = @City ,
    CompanyName = @CompanyName ,
    ContactName = @ContactName ,
    ContactTitle = @ContactTitle ,
    Country = @Country ,
    EMail   = @Email,
    Fax     = @Fax ,
    Phone   = @Phone,
    PostalCode = @PostalCode ,
    Region  = @Region,
    WebSite = @WebSite 
Where CustomerID = @CustomerID";
            context.Command.Parameters.AddParameter("Address", obj.Address);
            context.Command.Parameters.AddParameter("City", obj.City);
            context.Command.Parameters.AddParameter("CompanyName", obj.CompanyName);
            context.Command.Parameters.AddParameter("ContanctName", obj.ContactName);
            context.Command.Parameters.AddParameter("ContactTitle", obj.ContactTitle);
            context.Command.Parameters.AddParameter("Country", obj.Country);
            context.Command.Parameters.AddParameter("EMail", obj.Email);
            context.Command.Parameters.AddParameter("Fax", obj.Fax);
            context.Command.Parameters.AddParameter("Phone", obj.Phone);
            context.Command.Parameters.AddParameter("PostalCode", obj.PostalCode);
            context.Command.Parameters.AddParameter("Region", obj.Region);
            context.Command.Parameters.AddParameter("WebSite", obj.WebSite);
            context.Command.Parameters.AddParameter("CustomerID", obj.ID);

            return true;
        }

        public override string SelectCommandText
        {
            get
            {
                return "Select CustomerID , Address , City , CompanyName , ContactName , ContactTitle , Country , Email, Fax , Phone , PostalCode , Region , WebSite From Customers";
            }
        }

        [Serializable()]
        public class CustomerClassORMTemp : CustomerClass
        {
            public CustomerClassORMTemp()
            {
            }

            [System.ComponentModel.Browsable( false )]
            [System.Xml.Serialization.XmlIgnore()]
            [NonSerialized()]
            internal ORMEngine _Work = null;

            /// <summary>
            /// Handle delay load
            /// </summary>
            [System.ComponentModel.EditorBrowsable(  System.ComponentModel.EditorBrowsableState.Never )]
            public override List<OrderClass> Orders
            {
                get
                {
                    if (base.Orders == null && this._Work != null )
                    {
                        
                        OrderClass conditionInstance = new OrderClass();
                        conditionInstance.Customer = this ;
                        
                        Array list = this._Work.ReadInstancesByCondition( 
                            conditionInstance ,
                            new string[]{"Customer" } );
                        
                        List<OrderClass> result = new List<OrderClass>();

                        foreach (OrderClass item in list)
                        {
                            result.Add(item);
                        }

                        base.Orders = result;
                    }
                    return base.Orders;
                }
                set
                {
                    base.Orders = value;
                }
            }
        }//public class CustomerClassORMTemp : CustomerClass

    }//public class CustomerClassORMTypeMappingHelper : ORMTypeMappingHelper
}
