﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace XDesigner.ORM.Test
{
    public partial class frmMain : Form
    {
        public frmMain()
        {
            InitializeComponent();
        }
         
        private void ShowChildForm(Type frmType)
        {
            foreach (Form frm in this.MdiChildren)
            {
                if (frm.GetType().Equals(frmType))
                {
                    frm.Activate();
                    return;
                }
            }
            Form newForm = (Form)System.Activator.CreateInstance(frmType);
            newForm.MdiParent = this;
            newForm.Show();
            newForm.WindowState = FormWindowState.Maximized;
        }

        private void btnReadCustomers_Click(object sender, EventArgs e)
        {
            ShowChildForm(typeof(frmReadCustomers));
        }

        private void btnReadTree_Click(object sender, EventArgs e)
        {
            ShowChildForm(typeof(frmReadCustomerTree));
        }

        private void myTimer_Tick(object sender, EventArgs e)
        {
            myStatusLabel.Text = "ExecuteCommand:" + ORMPerformanceCounter.GetValue("ExecuteCommand") + " Instances:" + ORMPerformanceCounter.GetValue("Instance");
        }

        private void btnGenerateHelperCode_Click(object sender, EventArgs e)
        {
            ShowChildForm(typeof(frmGenerateHelperCode));
        }
    }
}