using System;
using System.Text;
using System.ComponentModel;
using System.Windows.Forms.Design;
using System.Drawing.Design;

namespace XDesigner.Script
{
    public class ScriptOptionsEditor : UITypeEditor
    {
        public ScriptOptionsEditor()
        {
        }

        public override UITypeEditorEditStyle GetEditStyle(ITypeDescriptorContext context)
        {
            return UITypeEditorEditStyle.Modal;
        }
        public override object EditValue(
            ITypeDescriptorContext context,
            IServiceProvider provider, 
            object Value)
        {
            XVBAOptions opt = Value as XVBAOptions;
            if (opt == null)
            {
                opt = new XVBAOptions();
            }
            else
            {
                opt = opt.Clone();
            }
            IWindowsFormsEditorService svc = (IWindowsFormsEditorService)provider.GetService(
                typeof(IWindowsFormsEditorService));
            using (dlgScriptOptions dlg = new dlgScriptOptions())
            {
                dlg.OptionsInstance = opt;
                if (svc.ShowDialog(dlg) == System.Windows.Forms.DialogResult.OK)
                {
                    return opt;
                }
            }
            return Value;
        }
    }
}
