using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace XDesigner.Script
{
    public partial class dlgBrowseGACAssembly : Form
    {
        public dlgBrowseGACAssembly()
        {
            InitializeComponent();
            this.DialogResult = DialogResult.Cancel;
        }

        private DotNetAssemblyInfo mySelectedAssembly = null;

        public DotNetAssemblyInfo SelectedAssembly
        {
            get
            {
                return mySelectedAssembly; 
            }
            set
            {
                mySelectedAssembly = value; 
            }
        }
        
        private void dlgBrowseGACAssembly_Load(object sender, EventArgs e)
        {
            foreach ( DotNetAssemblyInfo info in DotNetAssemblyInfoList.GlobalList )
            {
                ListViewItem item = new ListViewItem(info.Name);
                item.SubItems.Add(info.VersionString);
                item.SubItems.Add(info.FileName );
                item.Tag = info ;
                lvwAssembly.Items.Add(item);
            }
        }

        private void cmdOK_Click(object sender, EventArgs e)
        {
            if (lvwAssembly.SelectedItems.Count > 0)
            {
                ListViewItem item = lvwAssembly.SelectedItems[0];
                mySelectedAssembly = (DotNetAssemblyInfo)item.Tag;
                this.DialogResult = DialogResult.OK;
                this.Close();
            }
        }

        private void cmdCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}